"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleContainer = require("@cloudflare/style-container");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var fontSizes = {
  normal: 3,
  small: 2
};
var lineHeights = {
  small: 1.25
};
var colors = {
  info: 'blue.4',
  success: 'green.5',
  warning: 'orange.6',
  error: 'red.3',
  muted: 'gray.4'
};
var fontWeights = {
  normal: 400,
  bold: 700,
  'semi-bold': 600
};
var textAlign = {
  start: 'left',
  center: 'center',
  justify: 'justify',
  end: 'right'
};

var styles = function styles(_ref) {
  var size = _ref.size,
      weight = _ref.weight,
      align = _ref.align,
      type = _ref.type,
      textCase = _ref.case;
  return {
    color: type && colors[type],
    lineHeight: size && lineHeights[size],
    fontSize: size && fontSizes[size],
    fontWeight: weight && fontWeights[weight],
    textAlign: align && textAlign[align],
    textTransform: textCase,
    '&:first-letter': {
      textTransform: textCase && textCase === 'titlecase' && 'capitalize'
    }
  };
};

var Text = /*#__PURE__*/function (_React$Component) {
  _inherits(Text, _React$Component);

  var _super = _createSuper(Text);

  function Text() {
    _classCallCheck(this, Text);

    return _super.apply(this, arguments);
  }

  _createClass(Text, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          role = _this$props.role,
          children = _this$props.children;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: className,
        role: role
      }, children);
    }
  }]);

  return Text;
}(_react.default.Component);

Text.propTypes = {
  size: _propTypes.default.oneOf(['normal', 'small']),
  weight: _propTypes.default.oneOf(['normal', 'semi-bold', 'bold']),
  align: _propTypes.default.oneOf(['start', 'center', 'justify', 'end']),
  type: _propTypes.default.oneOf(['info', 'success', 'warning', 'error', 'muted']),
  case: _propTypes.default.oneOf(['capitalize', 'titlecase', 'lowercase', 'uppercase']),
  role: _propTypes.default.string,
  className: _propTypes.default.string.isRequired,
  children: _propTypes.default.node
};
Text.defaultProps = {
  weight: 'normal'
};
Text.displayName = 'Text';

var _default = (0, _styleContainer.createStyledComponent)(styles, Text, ['role']);

exports.default = _default;